#define NUMERO_VERSION "0.07b"

// Debug
#define DEBUG
//#define NODEBUG

// Langue
//#define ENGLISH
#define FRENCH

// Choix du systeme MsDos, Linux, PowerPC, MacOS ou Unix
#define MSDOS
//#define LINUX
//#define POWERPC
//#define UNIX
//#define MAC

/*
 Pcott MSDOS
 -------------
 Emulateur/Debugger PC 8086 par :
  - Julien Frelat "Gollum"
    Main Code/MsDos Port/Unix Port/HomePage Maintener
*/

#ifdef MSDOS
 // Librairies MsDos
// #include <dos.h>
// #include <conio.h>
 #include "g_dos.h"
#endif
// Librairies communes
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "g_utils.h"

#include "types.h"
#include "tables.h"
#include "i86.h"

static unsigned long INSTR,INSTR2; // Compteur d'instructions

static char *PCName;   // Nom du fichier COM a charger
static int PCSize;     // Taille du fichier COM
static char *ImagName; // Nom du fichier BMP (screenshot) a sauver
static byte *PCMemory; // Memoire PC (1024Ko)
static char keys[256]; // Touches Clavier
static char TEXT[256]; // Chaine de travail

int Stats[512];

FILE *DebugFile;

// Variables PC

// Booleens de controle

// Definition des codes touches MsDos
#define K_RESET        0x0E //BackSpace
#define K_SAVE_SCREEN  0x3C //F2 (BMP FORMAT)
#define K_SAVE_SCREEN2 0x3D //F3 (PCX FORMAT)
#define K_SAVE_SNAP    0x3F //F5
#define K_LOAD_SNAP    0x40 //F6
#define K_HALT         0x58 //F12
#define K_PAUSE        0x19 //P

static int Debug=1;     // Mode DEBUG (affichage des messages)
static int runto=0;     // Mode "Execution jusqu'a une certaine adresse"
static int Autorun=0;   // Mode "Autoexecution"
static int Fin=0;       // Pour quitter l'emulation (ESC)
static int ResetKey=0;  // Pour activer le RESET (BackSpace)
static int ImageKey=0;  // Pour activer le SCREENSHOT (F2)
static int SnapSKey=0;  // Pour activer le SAVE SNAPSHOT (F5)
static int SnapLKey=0;  // Pour activer le LOAD SNAPSHOT (F6)
static int PauseKey=0;  // Pour activer la PAUSE (P)
static int HaltKey=0;   // Pour activer le HALT (F12)
static byte FrameSkip=1;  // Frame Skipping (default 1/2)
static int Nojoy=0;       // Pas de detection du Joystick
static int Vsync=0;       // Attente VBL
static byte PALCYCLE=0;   // Cycle PALETTE (VGA TRICK)
static byte PALVALUE=0;   // PALETTE VALUE (VGA TRICK)

static byte PAIR[256];  // Tableau pour le flag PF

static void Init()
// Initialise l'emulation
{
 // Buffer de travail memoire
 #ifdef FRENCH
  printf("Allocation de 1024Ko pour la memoire\n");
 #else
  printf("1024Ko allocation for memory\n");
 #endif

 if (!Nojoy)
 {
  #ifdef FRENCH
   if (Joy_Detect()==1) printf("Joystick detecte\n");
   if (Joy_Detect()==2) printf("Joystick A detecte\nJoystick B detecte\n");
  #else
   if (Joy_Detect()==1) printf("Joystick found\n");
   if (Joy_Detect()==2) printf("Joystick A found\nJoystick B found\n");
  #endif
 }
}

static void Reset()
// RAZ les registres, les ports, etc...
{
 word i,j,count;

 AX=0x0000;
 BX=0x0000;
 CX=0x0000;
 DX=0x0000;
 SP=0xFFFE;
 BP=0x0000;
 SI=0x0000;
 DI=0x0000;
 DS=0x1586;
 ES=0x1586;
 SS=0x1586;
 CS=0x1586;
  
 IP=0x0100;     // Origine du programme

 for(i=0; i<256; i+=1)
 {
  count=0;	
  for (j=i; j>0; j>>=1) if (j&1) count++;
  PAIR[i]=!(count&1);
 }

 SF=CF=AF=OF=TF=IF=DF=0;
 ZF=PF=1;
}

#ifdef MSDOS
void (__interrupt _far *IRQ9Old)();

void __interrupt DonneTouche(void)
{
 char ScanCode,KeyCode,N,Touche;
 char *Aux=(char *)0x41C;
 char *Aux2=(char *)0x41A;

 _disable();
 // Vide le buffer clavier pour eviter une saturation des touches
 *Aux=*Aux2;
 // Recupere un code touche
 ScanCode = inp(0x60) ;
 KeyCode = (ScanCode & 0x7F) ;
 // Met a jour le booleen de la touche (appuyee ou relachee)
 if ((ScanCode & 0x80)==0)
 {
  keys[KeyCode] = 1;
  Fin=keys[1];
 }
 else
 {
  keys[KeyCode] = 0;
  if (!keys[K_RESET]) ResetKey=0;
  if (!keys[K_SAVE_SCREEN]) ImageKey=0;
  if (!keys[K_SAVE_SNAP]) SnapSKey=0;
  if (!keys[K_LOAD_SNAP]) SnapLKey=0;
  if (!keys[K_PAUSE]) PauseKey=0;
  if (!keys[K_HALT]) HaltKey=0;
 }
 // Remet a zero le clavier
 N = inp(0x61) ;
 outp(0x61, (N | 0x80)) ;
 outp(0x61, N ) ;
 outp(0x20,0x20);
 _enable();
}

static void init_clavier(void)
{
 _disable();
 IRQ9Old=_dos_getvect(0x09);
 _dos_setvect(0x09,DonneTouche);
 _enable();
}

static void finit_clavier(void)
{
 _disable();
 _dos_setvect(0x09,IRQ9Old);
 _enable();
}
#endif

#ifdef MSDOS
 #define TestKey(Touche) keys[Touche]
#endif

static byte ReadMemory(register dword adress)
{
 return(PCMemory[adress]);
}

static byte FetchB()
{
 IP+=1;
 return(ReadMemory((CS<<4)+IP));
}

static byte InPortB(register word adress)
{
 byte i;
 switch(adress)
 {
  /* CLAVIER */ case 0x060:
        for(i=0;i<256;i+=1)
         if (TestKey(i)) return i;
        return 0;
        break;
  /* RGB DEF */ case 0x3C9:
        return inp(adress);
  default:
        return 0;
 }
}

static OutPortB(register word adress, register byte valeur)
{
 switch(adress)
 {
  /* GET RGB */ case 0x3C7:
  /* PUT RGB */ case 0x3C8:
/*        outp(adress,valeur); PALVALUE=valeur; PALCYCLE=0;
        printf("P[%04X]=%02X|",adress,valeur);
        break;*/
  /* RGB DEF */ case 0x3C9:
/*        PALCYCLE++;
        if(PALCYCLE==4) 
        {
         PALCYCLE=0; outp(0x3C8,++PALVALUE);
         printf("P[03C8]=%02X|",PALVALUE);
        }*/
        outp(adress,valeur);
//        printf("P[%04X]=%02X|",adress,valeur);
        break;
 }
}

static OutPortW(register word adress, register word valeur)
{
 switch(adress)
 {
  /* GET RGB */ case 0x3C7:
  /* PUT RGB */ case 0x3C8:
  /* RGB DEF */ case 0x3C9:
        outpw(adress,valeur);
        break;
 }
}

static ActionMemory(register dword adress, register byte valeur)
{
 if ((adress>=0xA0000)&&(adress<0xB0000))
 {
  /* AFFICHAGE MEMOIRE VIDEO */
  SCREEN[adress-0xA0000]=valeur;
  PCMemory[adress]=valeur;
 }
 else PCMemory[adress]=valeur;
}

static GEN_INT_imm8()
{
 byte numint=FetchB();
 IP+=1;
 switch(numint)
 {
  /* VIDEO */ case 0x10 :
        switch(AH)
        {
         /* INIT VIDEO MODE */ case 0x00 :
                switch(AL)
                {
                 /* DOS */              case 0x03 :
                        #ifdef MSDOS
                        InitDOS();          
                        #endif
                        break;
                 /* MCGA 320x200x256 */ case 0x13 :
                        #ifdef MSDOS
                        Init320x200();          
                        #endif
                        break;
                }
                break;
        }
        break;
 }
}

static Emule(int code)
{
//  Stats[code]++;
//  INSTR2++;

  switch(code)
    {
    /* ADD RM8,R8   */ case 0x00 : GEN_ADD_rm8_r8; break;
    /* ADD RM16,R16 */ case 0x01 : GEN_ADD_rm16_r16; break;
    /* ADD R8,RM8   */ case 0x02 : GEN_ADD_r8_rm8; break;
    /* ADD R16,RM16 */ case 0x03 : GEN_ADD_r16_rm16; break;
    /* ADD AL,XX    */ case 0x04 : GEN_ADD_AL_imm8; break;
    /* ADD AX,XXXX  */ case 0x05 : GEN_ADD_AX_imm16; break;
    /* PUSH ES      */ case 0x06 : GEN_PUSH(ES); IP+=1; break;
    /* POP ES       */ case 0x07 : GEN_POP(ES); IP+=1; break;
    /* OR RM8,R8    */ case 0x08 : GEN_OR_rm8_r8; break;
    /* OR RM16,R16  */ case 0x09 : GEN_OR_rm16_r16; break;
    /* OR R8,RM8    */ case 0x0A : GEN_OR_r8_rm8; break;
    /* OR R16,RM16  */ case 0x0B : GEN_OR_r16_rm16; break;
    /* OR AL,XX     */ case 0x0C : GEN_OR_AL_imm8; break;
    /* OR AX,XXXX   */ case 0x0D : GEN_OR_AX_imm16; break;
    /* PUSH CS      */ case 0x0E : GEN_PUSH(CS); IP+=1; break;

    /* ADC RM8,R8   */ case 0x10 : GEN_ADC_rm8_r8; break;
    /* ADC RM16,R16 */ case 0x11 : GEN_ADC_rm16_r16; break;
    /* ADC R8,RM8   */ case 0x12 : GEN_ADC_r8_rm8; break;
    /* ADC R16,RM16 */ case 0x13 : GEN_ADC_r16_rm16; break;
    /* ADC AL,XX    */ case 0x14 : GEN_ADC_AL_imm8; break;
    /* ADC AX,XXXX  */ case 0x15 : GEN_ADC_AX_imm16; break;
    /* PUSH SS      */ case 0x16 : GEN_PUSH(SS); IP+=1; break;
    /* POP SS       */ case 0x17 : GEN_POP(SS); IP+=1; break;
    /* SBB RM8,R8   */ case 0x18 : GEN_SBB_rm8_r8; break;
    /* SBB RM16,R16 */ case 0x19 : GEN_SBB_rm16_r16; break;
    /* SBB R8,RM8   */ case 0x1A : GEN_SBB_r8_rm8; break;
    /* SBB R16,RM16 */ case 0x1B : GEN_SBB_r16_rm16; break;
    /* SBB AL,XX    */ case 0x1C : GEN_SBB_AL_imm8; break;
    /* SBB AX,XXXX  */ case 0x1D : GEN_SBB_AX_imm16; break;
    /* PUSH DS      */ case 0x1E : GEN_PUSH(DS); IP+=1; break;
    /* POP DS       */ case 0x1F : GEN_POP(DS); IP+=1; break;
    /* AND RM8,R8   */ case 0x20 : GEN_AND_rm8_r8; break;
    /* AND RM16,R16 */ case 0x21 : GEN_AND_rm16_r16; break;
    /* AND R8,RM8   */ case 0x22 : GEN_AND_r8_rm8; break;
    /* AND R16,RM16 */ case 0x23 : GEN_AND_r16_rm16; break;
    /* AND AL,XX    */ case 0x24 : GEN_AND_AL_imm8; break;
    /* AND AX,XXXX  */ case 0x25 : GEN_AND_AX_imm16; break;


    /* SUB RM8,R8   */ case 0x28 : GEN_SUB_rm8_r8; break;
    /* SUB RM16,R16 */ case 0x29 : GEN_SUB_rm16_r16; break;
    /* SUB R8,RM8   */ case 0x2A : GEN_SUB_r8_rm8; break;
    /* SUB R16,RM16 */ case 0x2B : GEN_SUB_r16_rm16; break;
    /* SUB AL,XX    */ case 0x2C : GEN_SUB_AL_imm8; break;
    /* SUB AX,XXXX  */ case 0x2D : GEN_SUB_AX_imm16; break;


    /* XOR RM8,R8   */ case 0x30 : GEN_XOR_rm8_r8; break;
    /* XOR RM16,R16 */ case 0x31 : GEN_XOR_rm16_r16; break;
    /* XOR R8,RM8   */ case 0x32 : GEN_XOR_r8_rm8; break;
    /* XOR R16,RM16 */ case 0x33 : GEN_XOR_r16_rm16; break;
    /* XOR AL,XX    */ case 0x34 : GEN_XOR_AL_imm8; break;
    /* XOR AX,XXXX  */ case 0x35 : GEN_XOR_AX_imm16; break;


    /* CMP RM8,R8   */ case 0x38 : GEN_CMP_rm8_r8; break;
    /* CMP RM16,R16 */ case 0x39 : GEN_CMP_rm16_r16; break;
    /* CMP R8,RM8   */ case 0x3A : GEN_CMP_r8_rm8; break;
    /* CMP R16,RM16 */ case 0x3B : GEN_CMP_r16_rm16; break;
    /* CMP AL,XX    */ case 0x3C : GEN_CMP_AL_imm8; break;
    /* CMP AX,XXXX  */ case 0x3D : GEN_CMP_AX_imm16; break;


    /* INC AX       */ case 0x40 : GEN_INC16(AX); IP+=1; break;
    /* INC CX       */ case 0x41 : GEN_INC16(CX); IP+=1; break;
    /* INC DX       */ case 0x42 : GEN_INC16(DX); IP+=1; break;
    /* INC BX       */ case 0x43 : GEN_INC16(BX); IP+=1; break;
    /* INC SP       */ case 0x44 : GEN_INC16(SP); IP+=1; break;
    /* INC BP       */ case 0x45 : GEN_INC16(BP); IP+=1; break;
    /* INC SI       */ case 0x46 : GEN_INC16(SI); IP+=1; break;
    /* INC DI       */ case 0x47 : GEN_INC16(DI); IP+=1; break;
    /* DEC AX       */ case 0x48 : GEN_DEC16(AX); IP+=1; break;
    /* DEC CX       */ case 0x49 : GEN_DEC16(CX); IP+=1; break;
    /* DEC DX       */ case 0x4A : GEN_DEC16(DX); IP+=1; break;
    /* DEC BX       */ case 0x4B : GEN_DEC16(BX); IP+=1; break;
    /* DEC SP       */ case 0x4C : GEN_DEC16(SP); IP+=1; break;
    /* DEC BP       */ case 0x4D : GEN_DEC16(BP); IP+=1; break;
    /* DEC SI       */ case 0x4E : GEN_DEC16(SI); IP+=1; break;
    /* DEC DI       */ case 0x4F : GEN_DEC16(DI); IP+=1; break;
    /* PUSH AX      */ case 0x50 : GEN_PUSH(AX); IP+=1; break;
    /* PUSH CX      */ case 0x51 : GEN_PUSH(CX); IP+=1; break;
    /* PUSH DX      */ case 0x52 : GEN_PUSH(DX); IP+=1; break;
    /* PUSH BX      */ case 0x53 : GEN_PUSH(BX); IP+=1; break;
    /* PUSH SP      */ case 0x54 : GEN_PUSH(SP); IP+=1; break;
    /* PUSH BP      */ case 0x55 : GEN_PUSH(BP); IP+=1; break;
    /* PUSH SI      */ case 0x56 : GEN_PUSH(SI); IP+=1; break;
    /* PUSH DI      */ case 0x57 : GEN_PUSH(DI); IP+=1; break;
    /* POP AX       */ case 0x58 : GEN_POP(AX); IP+=1; break;
    /* POP CX       */ case 0x59 : GEN_POP(CX); IP+=1; break;
    /* POP DX       */ case 0x5A : GEN_POP(DX); IP+=1; break;
    /* POP BX       */ case 0x5B : GEN_POP(BX); IP+=1; break;
    /* POP SP       */ case 0x5C : GEN_POP(SP); IP+=1; break;
    /* POP BP       */ case 0x5D : GEN_POP(BP); IP+=1; break;
    /* POP SI       */ case 0x5E : GEN_POP(SI); IP+=1; break;
    /* POP DI       */ case 0x5F : GEN_POP(DI); IP+=1; break;
    /* PUSHA        */ case 0x60 : GEN_PUSHA; break;
    /* POPA         */ case 0x61 : GEN_POPA; break;






    /* PUSH XXXX    */ case 0x68 : GEN_PUSH_imm16; break;

    /* PUSH XX      */ case 0x6A : GEN_PUSH_imm8; break;



    /* OUTSB        */ case 0x6E : GEN_OUTSB; IP+=1; break;

    /* JO   xXX     */ case 0x70 : GEN_JMP_rel8(OF); break;
    /* JNO  xXX     */ case 0x71 : GEN_JMP_rel8(!OF); break;
    /* JB   xXX     */ case 0x72 : GEN_JMP_rel8(CF); break;
    /* JNB  xXX     */ case 0x73 : GEN_JMP_rel8(!CF); break;
    /* JZ   xXX     */ case 0x74 : GEN_JMP_rel8(ZF); break;
    /* JNZ  xXX     */ case 0x75 : GEN_JMP_rel8(!ZF); break;
    /* JBE  xXX     */ case 0x76 : GEN_JMP_rel8(CF||ZF); break;
    /* JNBE xXX     */ case 0x77 : GEN_JMP_rel8(!(CF||ZF)); break;
    /* JS   xXX     */ case 0x78 : GEN_JMP_rel8(SF); break;
    /* JNS  xXX     */ case 0x79 : GEN_JMP_rel8(!SF); break;
    /* JP   xXX     */ case 0x7A : GEN_JMP_rel8(PF); break;
    /* JNP  xXX     */ case 0x7B : GEN_JMP_rel8(!PF); break;
    /* JL   xXX     */ case 0x7C : GEN_JMP_rel8(SF!=OF); break;
    /* JNL  xXX     */ case 0x7D : GEN_JMP_rel8(SF==OF); break;
    /* JLE  xXX     */ case 0x7E : GEN_JMP_rel8((SF!=OF)&&ZF); break;
    /* JNLE xXX     */ case 0x7F : GEN_JMP_rel8((SF==OF)&&!ZF); break;
    /* GP1 RM8,XX   */ case 0x80 : GEN_GR1_rm8_imm8; break;
    /* GP1 RM16,XXXX*/ case 0x81 : GEN_GR1_rm16_imm16; break;

    /* GP1 RM16,xXX */ case 0x83 : GEN_GR1_rm16_rel8; break;

    /* XCHG RM8,R8  */ case 0x86 : GEN_XCHG_rm8_r8; break;

    /* MOV RM8,R8   */ case 0x88 : GEN_MOV_rm8_r8; break;
    /* MOV RM16,R16 */ case 0x89 : GEN_MOV_rm16_r16; break;
    /* MOV R8,RM8   */ case 0x8A : GEN_MOV_r8_rm8; break;
    /* MOV R16,RM16 */ case 0x8B : GEN_MOV_r16_rm16; break;
    /* MOV XXXX,SEG */ case 0x8C : GEN_MOV_rm16_seg; break;

    /* MOV SEG,XXXX */ case 0x8E : GEN_MOV_seg_rm16; break;
    /* NOP          */ case 0x90 : IP+=1; break;
    /* STOSW        */ case 0xAB : GEN_STOSW; break;
    /* MOV AL,XX    */ case 0xB0 : GEN_MOV_r8_imm8(AL); break;
    /* MOV CL,XX    */ case 0xB1 : GEN_MOV_r8_imm8(CL); break;
    /* MOV DL,XX    */ case 0xB2 : GEN_MOV_r8_imm8(DL); break;
    /* MOV BL,XX    */ case 0xB3 : GEN_MOV_r8_imm8(BL); break;
    /* MOV AH,XX    */ case 0xB4 : GEN_MOV_r8_imm8(AH); break;
    /* MOV CH,XX    */ case 0xB5 : GEN_MOV_r8_imm8(CH); break;
    /* MOV DH,XX    */ case 0xB6 : GEN_MOV_r8_imm8(DH); break;
    /* MOV BH,XX    */ case 0xB7 : GEN_MOV_r8_imm8(BH); break;
    /* MOV AX,XXXX  */ case 0xB8 : GEN_MOV_r16_imm16(AX); break;
    /* MOV CX,XXXX  */ case 0xB9 : GEN_MOV_r16_imm16(CX); break;
    /* MOV DX,XXXX  */ case 0xBA : GEN_MOV_r16_imm16(DX); break;
    /* MOV BX,XXXX  */ case 0xBB : GEN_MOV_r16_imm16(BX); break;
    /* MOV SP,XXXX  */ case 0xBC : GEN_MOV_r16_imm16(SP); break;
    /* MOV BP,XXXX  */ case 0xBD : GEN_MOV_r16_imm16(BP); break;
    /* MOV SI,XXXX  */ case 0xBE : GEN_MOV_r16_imm16(SI); break;
    /* MOV DI,XXXX  */ case 0xBF : GEN_MOV_r16_imm16(DI); break;
    /* RET          */ case 0xC3 : Fin=1; break;
    /* INT XX       */ case 0xCD : GEN_INT_imm8(); break;
    /* GRP2 RM8,1   */ case 0xD0 : GEN_GR2_rm8_1; break;
    /* IN AL,XX     */ case 0xE4 : /*AL=InPortB(FetchB());*/ IP+=1; break;
    /* OUT DX,AL    */ case 0xEE : OutPortB(DX,AL); IP+=1; break;
    /* OUT DX,AX    */ case 0xEF : OutPortW(DX,AX); IP+=1; break;
    /* REP/REPE     */ case 0xF3 : GEN_REP; break;
    /* CMC          */ case 0xF5 : CF=!CF; IP+=1; break;
    /* GRP3 RM8     */ case 0xF6 : GEN_GR3_rm8; break;
    /* GRP3 RM16    */ case 0xF7 : GEN_GR3_rm16; break;
    /* CLI          */ case 0xFA : IF=0; IP+=1; break;
    /* STI          */ case 0xFB : IF=1; IP+=1; break;
    /* CLD          */ case 0xFC : DF=0; IP+=1; break;
    /* STD          */ case 0xFD : DF=1; IP+=1; break;
    /* GRP4 RM8     */ case 0xFE : GEN_GR4_rm8; break;       
    default :
#ifdef DEBUG
    if (runto)
     #ifdef MSDOS
     InitDOS(); 		
     #endif
    #ifdef FRENCH
     printf("Instruction INCONNUE\n"); Debug=1; runto=0;
    #else
     printf("UNKNOWN Instruction\n"); Debug=1; runto=0;
    #endif
#else
    IP+=1;    
#endif
    }
}

#ifdef MSDOS
typedef struct BMP {
  word    Type;      /* must be 0x4D42 */
  word    Size;      /*mot de poids faible */
  word    Size2;     /*mot de poids fort */
  word    Reserved1; /* must be zero */
  word    Reserved2; /* must be zero */
  word    OffBits;
  word    OffBits2;
  word    biSize;
  word    biSize2;
  dword   Width; 
  dword   Height;
  word    Planes;
  word    BitCount;
  dword   Compression;
  dword   SizeImage;
  dword   XPelsPerMeter;
  dword   YPelsPerMeter;
  dword   ClrUsed;
  dword   ClrImportant;
} BMPHEADER;

static int Save_BMP(byte *buf,char *name)  
{  
 FILE *ToF;  
 int i,j;
 dword *ad1,*ad2;  
 byte *palette=new byte[1024];
 byte *realpal=new byte[768];
 byte *filebuf=new byte[64000];
 BMPHEADER *head=new BMPHEADER[sizeof(BMPHEADER)];
 // Test de l'existence du fichier  
 if ((ToF=fopen(name,"wb"))!=NULL)  
 {  
    head->Type=0x4D42;
    head->Size=65078;
    head->Size2=head->Reserved1=head->Reserved2=0;
    head->OffBits=1078;
    head->OffBits2=0;
    head->biSize=40;
    head->biSize2=0;
    head->Width=320;
    head->Height=200;
    head->Planes=1;
    head->BitCount=8;
    head->Compression=0;
    head->SizeImage=64000;
    head->XPelsPerMeter=head->YPelsPerMeter=0;
    head->ClrUsed=head->ClrImportant=256;

    for (i=0;i<256;i++)
    {
     outp(0x3c7,i);
     palette[(i<<2)+3]=0;
     palette[(i<<2)+2]=inp(0x3c9)<<2;
     palette[(i<<2)+1]=inp(0x3c9)<<2;
     palette[(i<<2)+0]=inp(0x3c9)<<2;
    }

    // On inverse les donnees de la texture (stockees a l'envers dans le BMP)
    // Pointeur sur premiere ligne de la texture  
    ad1=(dword *)buf;  
    // Pointeur sur derniere ligne de la texture  
    ad2=(dword *)filebuf+80*199;
    // On inverse la moitie des lignes du haut avec celles du bas  
    for (i=0;i<200;i+=1)  
    {  
     // Inversion de la ligne courante et de sa symetrique  
     for (j=0;j<80;j+=1) *ad2++=*ad1++;
     ad2-=160;  
    };  

    fwrite((void *)head,1,54,ToF);
    fwrite((void *)palette,1,1024,ToF);
    // On ecrit les donnees Bitmap (320*200=64000 octets)
    fwrite((void *)filebuf,1,64000,ToF);  
    fclose(ToF);  
    // Sortie sans erreur  
    return 1;  
 }
 else  
    // Erreur d'ouverture  
    return 0;  
}  

#endif

void AttenteVBL(void);
#pragma aux AttenteVBL = \ 
"mov    dx,03DAh" \ 
"vr1:" \ 
"in     al,dx" \ 
"test   al,8" \ 
"jz     vr1" \ 
"vr2:" \ 
"in     al,dx" \ 
"test   al,8" \ 
"jnz    vr2" \ 
modify [eax edx]; 

void Affiche_Help()
{
#ifdef FRENCH
 printf("q(uit)    : quitte le debugger\n");
 printf("n(ext)    : saute l'instruction sans l'executer\n");
 printf("j(ump)    : saute a une adresse precise\n");
 printf("r(un)     : execute jusqu'a une adresse precise\n"); 
 printf("d(isplay) : affiche le contenu d'une adresse memoire\n");
 printf("e(nter)   : modifie une adresse memoire\n");
 printf("o         : affiche les messages ON/OFF\n");
 printf("h(elp)    : affiche l'aide sur les commandes\n");
 printf("t(race)   : execution pas a pas\n");
 printf("g(o)      : lance l'emulation\n");
#else
 printf("q(uit)    : exit debugger\n");
 printf("n(ext)    : jump current instruction without executing it\n");
 printf("j(ump)    : jump to a specific adress\n");
 printf("r(un)     : execute until reaching a specific adress\n"); 
 printf("d(isplay) : display memory\n");
 printf("e(nter)   : modify value at a specific adress\n");
 printf("o         : toggle debug messages ON/OFF\n");
 printf("h(elp)    : display help about debug commands\n");
 printf("t(race)   : execute step by step\n");
 printf("g(o)      : run emulation\n");
#endif
}

typedef struct REGSPC {
 word ax;
 word bx;
 word cx;
 word dx;
 word sp;
 word bp;
 word si;
 word di;
 word ds;
 word es;
 word ss;
 word cs;
 word ip;
} REGISTRESPC;

void Load_SNAP(char *Name)
{
 FILE *SavFile;
 int SavSize;
 REGISTRESPC *registres=new REGISTRESPC[sizeof(REGISTRESPC)];
 
 if (SavFile=fopen(Name,"rb"))
 { 
  fread(PCMemory,1,0x100000,SavFile);
  fread(registres,1,26,SavFile);
  AX=registres->ax;
  BX=registres->bx;
  CX=registres->cx;
  DX=registres->dx;
  SP=registres->sp;
  BP=registres->bp;
  SI=registres->si;
  DI=registres->di;
  DS=registres->ds;
  ES=registres->es;
  SS=registres->ss;
  CS=registres->cs;
  IP=registres->ip;
  fclose(SavFile);
 }
}

void Save_SNAP(char *Name)
{
 FILE *SavFile;
 int SavSize;
 REGISTRESPC *registres=new REGISTRESPC[sizeof(REGISTRESPC)];

 if (SavFile=fopen(Name,"wb"))
 { 
  registres->ax=AX;
  registres->bx=BX;
  registres->cx=CX;
  registres->dx=DX;
  registres->sp=SP;
  registres->bp=BP;
  registres->si=SI;
  registres->di=DI;
  registres->ds=DS;
  registres->es=ES;
  registres->ss=SS;
  registres->cs=CS;
  IP=registres->ip;
  fwrite(PCMemory,1,0x100000,SavFile);
  fwrite(registres,1,26,SavFile);
  fclose(SavFile);
 }
}

static Test_SpecialKeys()
{
     if (TestKey(K_RESET)&&(!ResetKey))
     {
      Reset();
      _disable(); ResetKey=1; _enable();
     }
     else
     if (TestKey(K_PAUSE)&&(!PauseKey))
     {
      printf("");
      for(;;)
      {
       printf("");
       if (!TestKey(K_PAUSE)) break;
      };
      printf("");
      _disable(); PauseKey=1; _enable();
      for(;;)
      {
       printf("");
       if ((!PauseKey)) break;
      };
      printf("");
      _disable(); PauseKey=1; _enable();
     }
     else
     if (TestKey(K_SAVE_SCREEN)&&(!ImageKey))
     {
      strcpy(ImagName,PCName);
      char *pos=strchr(ImagName,'.');
      strcpy(pos,".bmp");
      Save_BMP(SCRBASE,ImagName);
      _disable(); ImageKey=1; _enable();
     }
     else
     if (TestKey(K_LOAD_SNAP)&&(!SnapLKey))
     // Load SNAPSHOT   
     {
      strcpy(ImagName,PCName);
      char *pos=strchr(ImagName,'.');
      strcpy(pos,".cot");
      Load_SNAP(ImagName);
      _disable(); SnapLKey=1; _enable();
     }
     else
     if (TestKey(K_SAVE_SNAP)&&(!SnapSKey))
     // Save SNAPSHOT   
     {
      strcpy(ImagName,PCName);
      char *pos=strchr(ImagName,'.');
      strcpy(pos,".cot");
      Save_SNAP(ImagName);
      _disable(); SnapSKey=1; _enable();
     }
     else
     if (TestKey(K_HALT)&&(!HaltKey))
     {
      _disable(); HaltKey=1; _enable();
      finit_clavier();
      InitDOS();
      Debug=1; runto=0;
     }
}

void Debugger()
{
 int i,j;
 word adresse,adrto=0,adr,ancIP;
 char *opcode=new char[16];
 char *newopcode=new char[16];
 char *posi,*posi2;
 char *ChMod=new char[16];
 char l,count,rl,next,next2,sign;
 char lu[10];
 int exec;
 word Retour;
 register byte code,ancode,modrm,regop,rm,mod;

 #ifdef NODEBUG
  Autorun=1; Debug=0; runto=1;
 #endif
 #ifdef NODEBUG
  #ifdef MSDOS
   init_clavier();
  #endif
  strcpy(lu,"\0");
 #else
  InitDOS();
 #endif
 Reset();
 CX=PCSize;
 strcpy(lu,"\0");
 for(;;)
 {
  if (!runto)
  {
   ancIP=IP;
   for(i=0;i<10;i+=1)
   {
      code=ReadMemory((CS<<4)+IP);
      l=1;
      if (i==0) printf(">"); else printf(" ");
      printf("%04X:%04X %02X",CS,IP,code);
      strcpy(opcode,Opcodes[code]);
      if (posi=strchr(opcode,'*'))
      {
       *posi=0; l+=1; next=FetchB();
       printf("%02X      %s%04X%s\n",next,opcode,IP+(signed char)next+1,posi+1);
      }
      else
      if (posi=strchr(opcode,'+'))
      {
       *posi=0; l+=2; next=FetchB(); next2=FetchB();
       printf("%02X%02X    %s%04X%s\n",next,next2,opcode,IP+(next2<<8)+next+1,posi+1);
      }
      else
      if (posi=strchr(opcode,'#'))
      {
       *posi=0; l+=2; next=FetchB(); next2=FetchB();
       printf("%02X%02X    %s%02X%02X%s\n",next,next2,opcode,next2,next,posi+1);
      }
      else
      if (posi=strchr(opcode,'@'))
      {
       *posi=0; l+=1; next=FetchB();
       printf("%02X      %s%02X%s\n",next,opcode,next,posi+1);
      }
      else
      if (!strcmp(opcode,"~1"))
      {
                l+=1; 
                modrm=FetchB(); 
		regop=(modrm&0x38)>>3; // mod=modrm>>6; 
		rm=modrm&0x07;
                strcpy(opcode,Grp1[regop]);
		posi=strchr(opcode,'&');
                *posi=0; l+=1; next2=FetchB();
                if (code==0x80)
                        printf("%02X%02X    %s %s,%02X\n",modrm,next2,opcode,Reg8[rm],next2);
                else
                        printf("%02X%02X    %s %s,%02X\n",modrm,next2,opcode,Reg16[rm],next2);
   	}
   	else
        if (!strcmp(opcode,"-1"))
   	{
                l+=1; 
                modrm=FetchB(); 
		regop=(modrm&0x38)>>3; // mod=modrm>>6; 
		rm=modrm&0x07;
                strcpy(opcode,Grp1[regop]);
		posi=strchr(opcode,'&');
                *posi=0; l+=1; next2=FetchB();
                if (next2&0x80)
                        printf("%02X%02X    %s %s,-%02X\n",modrm,next2,opcode,Reg16[rm],256-next2);
                else
                        printf("%02X%02X    %s %s,+%02X\n",modrm,next2,opcode,Reg16[rm],next2);
   	}
   	else
   	if (!strcmp(opcode,"~2"))
   	{
    		l+=1; 
                modrm=FetchB(); 
		regop=(modrm&0x38)>>3; // mod=modrm>>6; 
		rm=modrm&0x07;
		strcpy(opcode,Grp2[regop]);
                switch(code)
                {
                 case 0xC0 :
                  next2=FetchB(); l+=1;
                  printf("%02X%02X    %s %s,%02X\n",modrm,next2,opcode,Reg8[rm],next2);
                  break;
                 case 0xC1 :
                  next=FetchB(); next2=FetchB(); l+=2;
                  printf("%02X%02X%02X  %s %s,%02X%02X\n",modrm,next,next2,opcode,Reg16[rm],next2,next);
                  break;
                 case 0xD0 :
                  printf("%02X      %s %s,1\n",modrm,opcode,Reg8[rm]);
                  break;
                 case 0xD1 :
                  printf("%02X      %s %s,1\n",modrm,opcode,Reg16[rm]);
                  break;
                 case 0xD2 :
                  printf("%02X      %s %s,CL\n",modrm,opcode,Reg8[rm]);
                  break;
                 case 0xD3 :
                  printf("%02X      %s %s,CL\n",modrm,opcode,Reg16[rm]);
                  break;
                };
   	}
   	else
   	if (!strcmp(opcode,"~3"))
   	{
    		l+=1; 
                modrm=FetchB(); 
		regop=(modrm&0x38)>>3; // mod=modrm>>6; 
		rm=modrm&0x07;
		strcpy(opcode,Grp3[regop]);
		posi=strchr(opcode,'&');
                if (posi2=strchr(opcode,'b'))
                {
                 l+=1; *posi2=0; next2=FetchB();
                }
		*posi=0;
		if (code==0xF6)
                        strcpy(newopcode,Reg8[rm]);
                else
                        strcpy(newopcode,Reg16[rm]);
                if (posi2)
                        printf("%02X%02X    %s%s%s%02X\n",modrm,next2,opcode,newopcode,posi+1,next2);
                else
                        printf("%02X      %s%s%s\n",modrm,opcode,newopcode,posi+1);
   	}
   	else
        if (!strcmp(opcode,"~4"))
   	{
    		l+=1; 
                modrm=FetchB(); 
		regop=(modrm&0x38)>>3; // mod=modrm>>6; 
		rm=modrm&0x07;
                strcpy(opcode,Grp4[regop]);
		posi=strchr(opcode,'&');
		*posi=0;
                printf("%02X      %s%s%s\n",modrm,opcode,Reg8[rm],posi+1);
   	}
   	else
   	if (posi=strchr(opcode,'&'))
   	{
    		l+=1; *posi=0;
                printf("%02X      %s\n",FetchB(),opcode);
        }      
   	else
   	if (posi=strchr(opcode,'w'))
   	{
    		l+=1; *posi=0;
                modrm=FetchB();
		regop=(modrm&0x38)>>3; mod=modrm>>6; rm=modrm&0x07;
                switch(mod)
                {
                 case 0x00 : strcpy(ChMod,Mod00[rm]); break;
                 case 0x01 : strcpy(ChMod,Mod01[rm]); break;
                 case 0x02 : strcpy(ChMod,Mod10[rm]); break;
                 case 0x03 : strcpy(ChMod,Reg16[rm]); break;
                }
                if (posi=strchr(ChMod,'w'))
                {
                        *posi=0; l+=2; next=FetchB(); next2=FetchB();
                        printf("%02X%02X%02X  %s%s,%s%02X%02X%s\n",modrm,next,next2,opcode,Reg16[regop],ChMod,next2,next,posi+1);
                }
                else
                if (posi=strchr(ChMod,'b'))
                {
                        *posi=0; l+=1; next2=FetchB();
                        printf("%02X%02X    %s%s,%s%02X%s\n",modrm,next2,opcode,Reg16[regop],ChMod,next2,posi+1);
                }
                else
                        printf("%02X      %s%s,%s\n",modrm,opcode,Reg16[regop],ChMod);
   	}
   	else
        if (posi=strchr(opcode,'s'))
   	{
    		l+=1; *posi=0;
                modrm=FetchB();
		regop=(modrm&0x38)>>3; mod=modrm>>6; rm=modrm&0x07;
                switch(mod)
                {
                 case 0x00 : strcpy(ChMod,Mod00[rm]); break;
                 case 0x01 : strcpy(ChMod,Mod01[rm]); break;
                 case 0x02 : strcpy(ChMod,Mod10[rm]); break;
                 case 0x03 : strcpy(ChMod,Reg16[rm]); break;
                }
                if (posi=strchr(ChMod,'w'))
                {
                        *posi=0; l+=2; next=FetchB(); next2=FetchB();
                        printf("%02X%02X%02X  %s%s,%s%02X%02X%s\n",modrm,next,next2,opcode,SReg[regop],ChMod,next2,next,posi+1);
                }
                else
                if (posi=strchr(ChMod,'b'))
                {
                        *posi=0; l+=1; next2=FetchB();
                        printf("%02X%02X    %s%s,%s%02X%s\n",modrm,next2,opcode,SReg[regop],ChMod,next2,posi+1);
                }
                else
                        printf("%02X      %s%s,%s\n",modrm,opcode,SReg[regop],ChMod);
   	}
   	else
        if (posi=strchr(opcode,'g'))
   	{
    		l+=1; *posi=0;
                modrm=FetchB();
		regop=(modrm&0x38)>>3; mod=modrm>>6; rm=modrm&0x07;
                switch(mod)
                {
                 case 0x00 : strcpy(ChMod,Mod00[rm]); break;
                 case 0x01 : strcpy(ChMod,Mod01[rm]); break;
                 case 0x02 : strcpy(ChMod,Mod10[rm]); break;
                 case 0x03 : strcpy(ChMod,Reg16[rm]); break;
                }
                if (posi=strchr(ChMod,'w'))
                {
                        *posi=0; l+=2; next=FetchB(); next2=FetchB();
                        printf("%02X%02X%02X  %s%s%02X%02X%s,%s\n",modrm,next,next2,opcode,ChMod,next2,next,posi+1,SReg[regop]);
                }
                else
                if (posi=strchr(ChMod,'b'))
                {
                        *posi=0; l+=1; next=FetchB();
                        printf("%02X%02X    %s%s%02X%s,%s\n",modrm,next2,opcode,ChMod,next2,posi+1,SReg[regop]);
                }
                else
                        printf("%02X      %s%s,%s\n",modrm,opcode,ChMod,SReg[regop]);
   	}
   	else
   	if (posi=strchr(opcode,'m'))
   	{
    		l+=1; *posi=0;
                modrm=FetchB();
		regop=(modrm&0x38)>>3; mod=modrm>>6; rm=modrm&0x07;
                switch(mod)
                {
                 case 0x00 : strcpy(ChMod,Mod00[rm]); break;
                 case 0x01 : strcpy(ChMod,Mod01[rm]); break;
                 case 0x02 : strcpy(ChMod,Mod10[rm]); break;
                 case 0x03 : strcpy(ChMod,Reg16[rm]); break;
                }
                if (posi=strchr(ChMod,'w'))
                {
                        *posi=0; l+=2; next=FetchB(); next2=FetchB();
                        printf("%02X%02X%02X  %s%s%02X%02X%s,%s\n",modrm,next,next2,opcode,ChMod,next2,next,posi+1,Reg16[regop]);
                }
                else
                if (posi=strchr(ChMod,'b'))
                {
                        *posi=0; l+=1; next=FetchB();
                        printf("%02X%02X    %s%s%02X%s,%s\n",modrm,next2,opcode,ChMod,next2,posi+1,Reg16[regop]);
                }
                else
                        printf("%02X      %s%s,%s\n",modrm,opcode,ChMod,Reg16[regop]);
   	}
   	else
   	if (posi=strchr(opcode,'b'))
   	{
    		l+=1; *posi=0;
                modrm=FetchB();
		regop=(modrm&0x38)>>3; mod=modrm>>6; rm=modrm&0x07;
                switch(mod)
                {
                 case 0x00 : strcpy(ChMod,Mod00[rm]); break;
                 case 0x01 : strcpy(ChMod,Mod01[rm]); break;
                 case 0x02 : strcpy(ChMod,Mod10[rm]); break;
                 case 0x03 : strcpy(ChMod,Reg8[rm]); break;
                }
                if (posi=strchr(ChMod,'w'))
                {
                        *posi=0; l+=2; next=FetchB(); next2=FetchB();
                        printf("%02X%02X%02X  %s%s,%s%02X%02X%s\n",modrm,next,next2,opcode,Reg8[regop],ChMod,next2,next,posi+1);
                }
                else
                if (posi=strchr(ChMod,'b'))
                {
                        *posi=0; l+=1; next2=FetchB();
                        printf("%02X%02X    %s%s,%s%02X%s\n",modrm,next2,opcode,Reg8[regop],ChMod,next2,posi+1);
                }
                else
                        printf("%02X      %s%s,%s\n",modrm,opcode,Reg8[regop],ChMod);
   	}
   	else
   	if (posi=strchr(opcode,'p'))
   	{
    		l+=1; *posi=0;
                modrm=FetchB();
		regop=(modrm&0x38)>>3; mod=modrm>>6; rm=modrm&0x07;
                switch(mod)
                {
                 case 0x00 : strcpy(ChMod,Mod00[rm]); break;
                 case 0x01 : strcpy(ChMod,Mod01[rm]); break;
                 case 0x02 : strcpy(ChMod,Mod10[rm]); break;
                 case 0x03 : strcpy(ChMod,Reg8[rm]); break;
                }
                if (posi=strchr(ChMod,'w'))
                {
                        *posi=0; l+=2; next=FetchB(); next2=FetchB();
                        printf("%02X%02X%02X  %s%s%02X%02X%s,%s\n",modrm,next,next2,opcode,ChMod,next2,next,posi+1,Reg8[regop]);
                }
                else
                if (posi=strchr(ChMod,'b'))
                {
                        *posi=0; l+=1; next2=FetchB();
                        printf("%02X%02X    %s%s%02X%s,%s\n",modrm,next2,opcode,ChMod,next2,posi+1,Reg8[regop]);
                }
                else
                        printf("%02X      %s%s,%s\n",modrm,opcode,ChMod,Reg8[regop]);
   	}
      else printf("        %s\n",opcode);
      IP+=1;
//      IP+=l;
      if (!i) rl=l;
   };
   IP=ancIP; 
   code=ReadMemory((CS<<4)+IP);
   printf("AX=%04X BX=%04X CX=%04X DX=%04X SP=%04X BP=%04X SI=%04X DI=%04X\n",AX,BX,CX,DX,SP,BP,SI,DI);
   printf("DS=%04X ES=%04X SS=%04X CS=%04X %01X%01X%01X%01X%01X%01X%01X%01X%01X\n",DS,ES,SS,CS,OF&1,DF&1,IF&1,TF&1,SF&1,ZF&1,AF&1,PF&1,CF&1);
   printf("Pcott :->");
   gets(lu);
   if ((!strcmp(lu,"n"))||(!strcmp(lu,"next"))) IP+=rl;
   else
   if ((!strcmp(lu,"j"))||(!strcmp(lu,"jump")))
   {
    #ifdef FRENCH
     printf("Nouvelle adresse : ");
    #else
     printf("New adress : ");
    #endif
    scanf("%04X",&IP); gets(lu);
   }
   else
   if ((!strcmp(lu,"g"))||(!strcmp(lu,"go")))
   {
    #ifdef MSDOS
     init_clavier();
    #endif
    Autorun=1; Debug=0; runto=1;
    strcpy(lu,"\0");
   }
   else
   if ((!strcmp(lu,"r"))||(!strcmp(lu,"run")))
   {
    Autorun=0;
    #ifdef FRENCH
     printf("Nouvelle adresse : ");
    #else
     printf("New adress : ");
    #endif
    scanf("%04X",&adrto); gets(lu); runto=1;
   }
   else
   if (!strcmp(lu,"o"))
   {
    Debug=!Debug;
    #ifdef FRENCH
     if (Debug) printf("Messages actives\n");
     else printf("Messages desactives\n");
    #else
     if (Debug) printf("Messages activated\n");
     else printf("Messages desactived\n");
    #endif
   }
   else
   if ((!strcmp(lu,"e"))||(!strcmp(lu,"enter")))
   {
    #ifdef FRENCH
     printf("Entrer l'adresse memoire : ");
    #else
     printf("Enter memory adress : ");
    #endif
    scanf("%04X",&adr);
    printf("(%04X) = %02X\n",adr,ReadMemory((DS<<4)+adr));
    #ifdef FRENCH
     printf("Entrer la nouvelle valeur : ");
    #else
     printf("Enter new value : ");
    #endif
    scanf("%02X",&PCMemory[(DS<<4)+adr]);
    gets(lu);
   }
   else
   if ((!strcmp(lu,"d"))||(!strcmp(lu,"display")))
   {
    #ifdef FRENCH
     printf("Entrer l'adresse memoire : ");
    #else
     printf("Enter memory adress : ");
    #endif
    scanf("%04X",&adr);
    for(j=0;j<8;j+=1)
    {
     printf("(%04X) = ",adr+(j<<4));
     for(i=0;i<16;i+=1) printf("%02X",ReadMemory((DS<<4)+adr+(j<<4)+i));
     printf("\n");
    }
    gets(lu);
   }
   else
   if ((!strcmp(lu,"h"))||(!strcmp(lu,"help")))
   {
    Affiche_Help();
    gets(lu);
   }
   else
   if ((!strcmp(lu,"q"))||(!strcmp(lu,"quit")))
   {
    Fin=1;
    break;
   }
   else
   if ((!strcmp(lu,"t"))||(!strcmp(lu,"trace")))
   {
    if (Fin) break;
    Emule(code);
   }
  }
  else
  {
   Emule(ReadMemory((CS<<4)+IP));
   Test_SpecialKeys();
   if (Fin) break;
   if ((!Autorun)&&(IP==adrto)) {
    Debug=1;
    runto=0;
    #ifdef MSDOS
     InitDOS();
    #endif
   }
  }
 }

 #ifdef MSDOS
  InitDOS();
 #endif
}

char Upcase(char S)
{
 return ((S>='a')&&(S<='z'))?S-32:S;
}

char Locase(char S)
{
 return ((S>='A')&&(S<='Z'))?S+32:S;
}

void Lostring(char *S)
{
 int i;
 for(i=0;i<strlen(S);i++) S[i]=Locase(S[i]);
}

int Hexa(char S)
{
 static char Hex[]="0123456789ABCDEF";
 return (strchr(Hex,Upcase(S))-Hex);
}

int Nume(char S)
{
 static char Num[]="0123456789";
 return (strchr(Num,Upcase(S))-Num);
}

int Load_Com(char *NomFichier)
{
 FILE *PCFile;  
 char touche[10];

 if ((PCFile=fopen(NomFichier,"rb"))!=NULL)  
  {  
   PCMemory=new byte[0x100000];
   memset(PCMemory,0x00,0x100000);
   PCSize=FileSize(PCFile);
   fread(PCMemory+(dword)(0x15960),1,PCSize,PCFile);  
   fclose(PCFile);  
   #ifdef FRENCH
    printf("- Nom du programme : \"%s\"\n",PCName);
   #else
    printf("- Program name : \"%s\"\n",PCName);
   #endif
   #ifdef FRENCH
    printf("- Taille du fichier : %d octets",PCSize);
   #else
    printf("- File size : %d bytes",PCSize);
   #endif
   printf("\n");
   Init();
   printf("\nPress a key to continue...\n");
   strcpy(touche,'\0');
   gets(touche);
   return 1;
  }
 else  
   {
     // Erreur de chargement
       #ifdef FRENCH
        printf("ERREUR : Le fichier %s n'existe pas...\n",NomFichier);
       #else
        printf("ERROR : File %s does not exist...\n",NomFichier);
       #endif
     return 0;
   };
}

void Display_Syntaxe(char *s)
{
 #ifdef FRENCH
  printf("Syntaxe :\n");
  printf(" %s <nom_du_fichier[.COM]> [options]\n",s);
  printf("Options :\n");
  printf(" /f[rameskip] XX ou -f[rameskip] XX pour afficher 1 frame/XX\n");
  printf(" /j[oy] ou -j[oy] desactive la detection du joystick\n");
  printf(" /v[sync] ou -v[sync] active la synchro VBL\n");
  printf(" /h[elp] ou -h[elp] ou -? ou /? affiche l'aide\n");
 #else
  printf("Syntax :\n");
  printf(" %s <file_name[.COM]> [options]\n",s);
  printf("Options :\n");
  printf(" /f[rameskip] XX or -f[rameskip] XX to skip 1 frame/XX\n");
  printf(" /j[oy] ou -j[oy] disables joystick detection\n");
  printf(" /v[sync] ou -v[sync] enables VBL sync\n");
  printf(" /h[elp] or -h[elp] or -? or /? displays help\n");
 #endif
}

void Display_Entete()
{
 #ifdef MSDOS
  InitDOS();
 #endif
 printf("\n");
 printf("Pcott %s \n",NUMERO_VERSION);
 printf("----------- \n");
}

main(int ParamCount, char *ParamStr[])
{
 PCName=new char[256];
 ImagName=new char[256];
 int Aide,i,LINES;
 long T1,T2;

 DebugFile=fopen("debug.txt","wb");

 for(i=0;i<512;i++) Stats[i]=0;

// Display_Entete();
 if (ParamCount>1) Aide=1; else Aide=0;
 for(i=0;i<ParamCount;i++) Lostring(ParamStr[i]);
 i=1;
 while(i<ParamCount)
  switch(ParamStr[i][0])
  {
   case '-' : 
   case '/' : 
    if ((!strcmp(ParamStr[i]+1,"j"))||(!strcmp(ParamStr[i]+1,"joy"))) Nojoy=1;
    else
    if ((!strcmp(ParamStr[i]+1,"v"))||(!strcmp(ParamStr[i]+1,"vsync"))) Vsync=1;
    else
    if ((!strcmp(ParamStr[i]+1,"h"))||(!strcmp(ParamStr[i]+1,"help"))) Aide=0;
    else
    if ((!strcmp(ParamStr[i]+1,"f"))||(!strcmp(ParamStr[i]+1,"frameskip")))
     FrameSkip=atoi(ParamStr[++i])-1;
    i+=1;
    break;
   default : strcpy(PCName,ParamStr[i++]);
  };
 if (!strchr(PCName,'.')) strcat(PCName,".com");
 if (Aide)
 {
//  VesaModes();
  VESAMODE=0;
  Display_Entete();
  if (Load_Com(PCName))
  {
//   while(!kbhit());
//   printf("\n\n");
   Affiche_Help();
   T1=GetTimer();
   Debugger();
   T2=GetTimer();
  }
 }
 else
  Display_Syntaxe(ParamStr[0]);

 // Fin Normale du programme
 #ifdef MSDOS
  finit_clavier();
 #endif
 if ((T2-T1)/1000)
 {
  printf("Pcott Benchmark\n");
  printf("-----------------\n");
  printf("- i8086 core \n");
  printf("      Instructions/s IPS = %d\n",INSTR2/((T2-T1)/1000));
  printf("- GFX core \n");
  printf("      Frames/s FPS = %d\n",(INSTR*(FrameSkip+1))/((T2-T1)/1000));
 }
 for(i=0;i<256;i++)
  fprintf(DebugFile,"%d (%s) = %d\n",i,Opcodes[i],Stats[i]);
 fclose(DebugFile);
}
