// Cycles instructions usuelles (SYNCHRONISATION)
static byte Cycles[256] =
{
  4,12, 8, 8, 4, 4, 8, 4,20, 8, 8, 8, 4, 4, 8, 4,
  4,12, 8, 8, 4, 4, 8, 4, 8, 8, 8, 8, 4, 4, 8, 4,
  8,12, 8, 8, 4, 4, 8, 4, 8, 8, 8, 8, 4, 4, 8, 4,
  8,12, 8, 8,12,12,12, 4, 8, 8, 8, 8, 4, 4, 8, 4,
  4, 4, 4, 4, 4, 4, 8, 4, 4, 4, 4, 4, 4, 4, 8, 4,
  4, 4, 4, 4, 4, 4, 8, 4, 4, 4, 4, 4, 4, 4, 8, 4,
  4, 4, 4, 4, 4, 4, 8, 4, 4, 4, 4, 4, 4, 4, 8, 4,
  8, 8, 8, 8, 8, 8, 4, 8, 4, 4, 4, 4, 4, 4, 8, 4,
  4, 4, 4, 4, 4, 4, 8, 4, 4, 4, 4, 4, 4, 4, 8, 4,
  4, 4, 4, 4, 4, 4, 8, 4, 4, 4, 4, 4, 4, 4, 8, 4,
  4, 4, 4, 4, 4, 4, 8, 4, 4, 4, 4, 4, 4, 4, 8, 4,
  4, 4, 4, 4, 4, 4, 8, 4, 4, 4, 4, 4, 4, 4, 8, 4,
  8,12,12,12,12,16, 8,32, 8, 8,12, 0,12,12, 8,32,
  8,12,12, 0,12,16, 8,32, 8, 8,12, 0,12, 0, 8,32,
 12,12, 8, 0, 0,16, 8,32,16, 4,16, 0, 0, 0, 8,32,
 12,12, 8, 4, 0,16, 8,32,12, 8,16, 4, 0, 0, 8,32
};

// Noms des instructions usuelles (DEBUG)
static char *Opcodes[256] =
{
  "ADD p"    ,"ADD m"    ,"ADD b"   ,"ADD w"   ,"ADD AL,@" ,"ADD AX,#","PUSH ES"  ,"POP ES"   ,
  "OR p"     ,"OR m"     ,"OR b"    ,"OR w"    ,"OR AL,@"  ,"OR AX,#" ,"PUSH CS"  ,"DB 0F"    ,
  "ADC p"    ,"ADC m"    ,"ADC b"   ,"ADC w"   ,"ADC AL,@" ,"ADC AX,#","PUSH SS"  ,"POP SS"   ,
  "SBB p"    ,"SBB m"    ,"SBB b"   ,"SBB w"   ,"SBB AL,@" ,"SBB AX,#","PUSH DS"  ,"POP DS"   ,
  "AND p"    ,"AND m"    ,"AND b"   ,"AND w"   ,"AND AL,@" ,"AND AX,#","SEG=ES"   ,"DAA"      ,
  "SUB p"    ,"SUB m"    ,"SUB b"   ,"SUB w"   ,"SUB AL,@" ,"SUB AX,#","SEG=CS"   ,"DAS"      ,
  "XOR p"    ,"XOR m"    ,"XOR b"   ,"XOR w"   ,"XOR AL,@" ,"XOR AX,#","SEG=SS"   ,"AAA"      ,
  "CMP p"    ,"CMP m"    ,"CMP b"   ,"CMP w"   ,"CMP AL,@" ,"CMP AX,#","SEG=CS"   ,"AAS"      ,
  "INC AX"   ,"INC CX"   ,"INC DX"  ,"INC BX"  ,"INC SP"   ,"INC BP"  ,"INC SI"   ,"INC DI"   ,
  "DEC AX"   ,"DEC CX"   ,"DEC DX"  ,"DEC BX"  ,"DEC SP"   ,"DEC BP"  ,"DEC SI"   ,"DEC DI"   ,
  "PUSH AX"  ,"PUSH CX"  ,"PUSH DX" ,"PUSH BX" ,"PUSH SP"  ,"PUSH BP" ,"PUSH SI"  ,"PUSH DI"  ,
  "POP AX"   ,"POP CX"   ,"POP DX"  ,"POP BX"  ,"POP SP"   ,"POP BP"  ,"POP SI"   ,"POP DI"   ,
  "PUSHA"    ,"POPA"     ,"BOUND ?" ,"ARPL ?"  ,"SEG=FS"   ,"SEG=GS"  ,"DB 66"    ,"DB 67"    ,
  "PUSH @"   ,"IMUL ?"   ,"PUSH @"  ,"IMUL ?"  ,"INSB"     ,"INSW"    ,"OUTSB"    ,"OUTSW"    ,
  "JO *"     ,"JNO *"    ,"JB *"    ,"JNB *"   ,"JZ *"     ,"JNZ *"   ,"JBE *"    ,"JNBE *"   ,
  "JS *"     ,"JNS *"    ,"JP *"    ,"JNP *"   ,"JL *"     ,"JNL *"   ,"JLE *"    ,"JNLE *"   ,
  "~1"       ,"~1"   ,"??"      ,"-1"      ,"TEST b"   ,"TEST w"  ,"XCHG b"   ,"XCHG w"   ,
  "MOV p"    ,"MOV m"    ,"MOV b"   ,"MOV w"   ,"MOV g"    ,"LEA ??"  ,"MOV s"    ,"POP ??"   ,
  "NOP"      ,"XCHG CX"  ,"XCHG DX" ,"XCHG BX" ,"XCHG SP"  ,"XCHG BP" ,"XCHG SI"  ,"XCHG DI"  ,
  "CBW"      ,"CWD"      ,"CALL ?"  ,"WAIT"    ,"PUSHF ?"  ,"POPF ?"  ,"SAHF"     ,"LAHF"     ,
  "MOV AL?"  ,"MOV AX?"  ,"MOV,AL?" ,"MOV,AX?" ,"MOVSB"    ,"MOVSW"   ,"CMPSB"    ,"CMPSW"    ,
  "TEST AL,@","TEST AX,#","STOSB"   ,"STOSW"   ,"LODSB"    ,"LODSW"   ,"SCASB"    ,"SCASW"    ,
  "MOV AL,@" ,"MOV CL,@" ,"MOV DL,@","MOV BL,@","MOV AH,@" ,"MOV CH,@","MOV DH,@" ,"MOV BH,@" ,
  "MOV AX,#" ,"MOV CX,#" ,"MOV DX,#","MOV BX,#","MOV SP,#" ,"MOV BP,#","MOV SI,#" ,"MOV DI,#" , 
  "~2"       ,"~2"       ,"RET #"   ,"RET"     ,"LES ?"    ,"LDS ?"   ,"MOV ?"    ,"MOV ?"    ,
  "ENTER ?"  ,"LEAVE"    ,"RET #"   ,"RET"     ,"INT 03"   ,"INT @"   ,"INTO"     ,"IRET"     ,
  "~2"       ,"~2"       ,"~2"      ,"~2"      ,"AAM"      ,"AAD"     ,"??"       ,"XLAT"     ,
  "ESC"      ,"ESC"      ,"ESC"     ,"ESC"     ,"ESC"      ,"ESC"     ,"ESC"      ,"ESC"      ,
  "LOOPNE"   ,"LOOPE"    ,"LOOP"    ,"JCXZ"    ,"IN AL,@"  ,"IN AX,@" ,"OUT @,AL" ,"OUT @,AX" ,
  "CALL +"   ,"JNP ?"    ,"JNP ?"   ,"JNP ?"   ,"IN AL,DX" ,"IN AX,DX","OUT DX,AL","OUT DX,AX",
  "LOCK"     ,"??"       ,"REPNE"   ,"REP/REPE","HLT"      ,"CMC"     ,"~3"       ,"~3"       ,
  "CLC"      ,"STC"      ,"CLI"     ,"STI"     ,"CLD"      ,"STD"     ,"~4"       ,"~5"       
};

// Noms des registres r8 usuels pour le Mod R/M ou MOD 11(DEBUG)
static char *Reg8[8] =
{
 "AL","CL","DL","BL","AH","CH","DH","BH"
};

// Noms des registres r16 usuels pour le Mod R/M ou MOD 11(DEBUG)
static char *Reg16[8] =
{
 "AX","CX","DX","BX","SP","BP","SI","DI"
};

// Noms des registres segments usuels pour le Mod R/M (DEBUG)
static char *SReg[8] =
{
 "ES","CS","SS","DS","??","??","??","??"
};

static char *Mod00[8] =
{
 "[BX+SI]","[BX+DI]","[BP+SI]","[BP+DI]","[SI]","[DI]","w","[BX]"
};

static char *Mod01[8] =
{
 "[BX+SI+b]","[BX+DI+b]","[BP+SI+b]","[BP+DI+b]","[SI+b]","[DI+b]","[BP+b]","[BX+b]"
};

static char *Mod10[8] =
{
 "[BX+SI+w]","[BX+DI+w]","[BX+SI+w]","[BX+DI+w]","[SI+w]","[DI+w]","[BP+w]","[BX+w]"
};

// Noms des opcodes Grp1 (DEBUG)
static char *Grp1[8] =
{
 "ADD","OR","ADC","SBB","AND","SUB","XOR","CMP"
};

// Noms des opcodes Grp2 (DEBUG)
static char *Grp2[8] =
{
 "ROL","ROR","RCL","RCR","SHL","SHR","??","SAR"
};

// Noms des opcodes Grp3 (DEBUG)
static char *Grp3[8] =
{
 "TEST &,b","??","NOT &","NEG &","MUL &","IMUL &","DIV &","IDIV &"
};

// Noms des opcodes Grp4 (DEBUG)
static char *Grp4[8] =
{
 "INC &","DEC &","??","??","??","??","??","??"
};

// Noms des opcodes Grp5 (DEBUG)
static char *Grp5[8] =
{
 "INC &","DEC &","CALL &","??","JMP &","??","PUSH &","??"
};
