#include "g_dos.h"

Zone::Zone(int fx,int fy,char *ftext)
{
	x=fx; y=fy; Texte=ftext;
};

Bouton::Bouton(int fx,int fy,int fcoul,char *ftext):Zone(fx,fy,ftext)
{
	coul=fcoul;
};

Bouton::Affiche()
{
//        Display_Text(SCREEN,x,y,Texte,0);
        int i;
//        for(i=0;i<256;i++)
//                PutPixel(i,0,i);
};

void PutPixel(int x, int y, int c)
{
 SCREEN[SCRWIDTH*y+x]=c;
}

long GetTimer(void)
// Gestion du TIMER
{
 timeb tp;
 ftime(&tp);
 return tp.time*1000+tp.millitm;
}

void Init320x200()
{
 static union REGS R;

 if (!VESAMODE)
 {
  R.x.eax=0x013;
  int386(0x10,&R,&R);
  SCREEN=SCRBASE;
  SCRWIDTH=320;
  SCRHEIGHT=200; 
  InitOfs();
  if (Mouse.Init()) Mouse.Show();
 }
 else
  InitVESA();        
}

void InitVESA()
{
  if (myScreen != NULL) vbeClose( myScreen );
  myScreen = vbeOpen(SCRWIDTH,SCRHEIGHT,8);
  if(myScreen == NULL)
  {
    printf("Could not set %4d x %-4d mode\n",SCRWIDTH,SCRHEIGHT);
    exit(0);
  }
  SCREEN = (byte *)myScreen->lfb;
  InitOfs();
  if (Mouse.Init()) Mouse.Show();
}

void InitOfs()
{
  STARTOFS=((dword *)SCREEN)+((SCRWIDTH*(((SCRHEIGHT-200)>>1)+16)+((SCRWIDTH-160)>>1))>>2);
  STARTOFS2=((byte *)SCREEN)+SCRWIDTH*((SCRHEIGHT-288)>>1)+((SCRWIDTH-320)>>1);
  INCROFS=(SCRWIDTH-160)>>2;
  INCROFS2=(SCRWIDTH<<1)-320;
}

void InitDOS()
{
 static union REGS R;
 R.x.eax=0x003;
 int386(0x10,&R,&R);
}

void VesaModes()
{
  VBEMODEINFO vbeModeInfo;
  VBEINFO *vbeInfo;
  unsigned short *vbeMode;
  int Choix=0;
  int Nb;
  int i,j,aux;
  struct
  {
   int x,y;
  } Modes[256];

  VESAMODE=0;
  // Detect the VBE bios
  if( (vbeInfo = vbeDetect()) == NULL )
  {
    printf("Can't find VESA bios extensions\n");
    exit(0);
  }
  // Check for VBE 2.0
  if( vbeInfo->VbeVersion < 0x200 )
  {
    printf("VESA bios extension 2.0 or better needed\n");
    exit(0);
  }
  vbeMode      = vbeInfo->VideoModePtr;
  while( *vbeMode != 0xFFFF )
  {
    if( vbeGetModeInfo(*vbeMode,&vbeModeInfo) )
    {
      if(( vbeModeInfo.ModeAttributes & VBEMODE_CAPS_LINEAR ) && (vbeModeInfo.BitsPerPixel==8))
	{	
         Modes[Choix].x=vbeModeInfo.XResolution;
         Modes[Choix++].y=vbeModeInfo.YResolution;
      }
    }
    vbeMode++;
  }
  if (Choix)
  {
   for(i=0;i<Choix;i++)
        for(j=i+1;j<Choix;j++)
                if ((Modes[i].x>Modes[j].x)||((Modes[i].x==Modes[j].x)&&(Modes[i].y>Modes[j].y)))
		{
			aux=Modes[i].x; Modes[i].x=Modes[j].x; Modes[j].x=aux;
			aux=Modes[i].y; Modes[i].y=Modes[j].y; Modes[j].y=aux;
		};	
   printf("Video Mode Selection\n");
   printf(" 0)  320 x 200 (SLOW)\n");
   for(i=0;i<Choix;i++)
   	printf("%2d) %4d x %-4d\n",
             i+1,
             Modes[i].x,
             Modes[i].y);
   printf("Selection : "); scanf("%d",&Nb);
   if (Nb)
   {
    Nb--;
    VESAMODE=1;
    SCRWIDTH=Modes[Nb&255].x;
    SCRHEIGHT=Modes[Nb&255].y;
   }
  }
}

int Load_FNT(char *name)
{  
 FILE *FromF;  
 int i,j;

 // Test de l'existence du fichier  
 if ((FromF=fopen(name,"rb"))!=NULL)  
 {  
    fread((void *)fontbuf,1,440*13,FromF);  
    fclose(FromF);  
 }
 else  
	// Erreur d'ouverture  
	return 0;  

 int pos=0;
 for(i=0;i<76;i++)
 {
  FontX[i]+=pos;
  pos+=FontWidth[i];
 }
 // Sortie sans erreur  
 return 1;  
}  

void Display_Letter(byte *buffer,int x,int y,int index,int mode,byte CE,byte CF)
{
 byte *ad1=(byte *)buffer+SCRWIDTH*y+x;
 byte *ad2=(byte *)fontbuf+FontX[index];
 int i,j;
 if (!mode)
 {
  for (i=0;i<13;i+=1)  
  {
   for (j=0;j<FontWidth[index];j+=1) *ad1++=(*ad2++==0)?CE:CF;
   ad1+=SCRWIDTH-FontWidth[index];
   ad2+=440-FontWidth[index];
  }
 }
 else
 {
  for (i=0;i<13;i+=1)  
  {
   for (j=0;j<FontWidth[index];j+=1)
   {
    if (*ad2++==0) *ad1++=CE; else ad1++;
   }
   ad1+=SCRWIDTH-FontWidth[index];
   ad2+=440-FontWidth[index];
  };
 }
}

int Pos_Letter(char l)
{
 int trouve=0;
 int i=0;
 while((!trouve)&&(i<78))
  if (FontText[i]==l) trouve=1; else i++;
 return i;
}

void Display_Text(byte *buffer,int x,int y,char *texte,int mode,byte CE,byte CF)
{
 int i,posi,cx;
 cx=x; 
 for(i=0;i<strlen(texte);i+=1)
 {
  posi=Pos_Letter(texte[i]);
  Display_Letter(buffer,cx,y,posi,mode,CE,CF);
  cx+=FontWidth[posi];
 }
}

int Len_Text(char *texte)
{
 int i,posi,cx;
 cx=0; 
 for(i=0;i<strlen(texte);i+=1)
 {
  posi=Pos_Letter(texte[i])+1;
  cx+=FontWidth[posi];
 }
 return cx;
}

int BMP_to_FNT(char *name)
{  
 FILE *FromF,*ToF;  
 int i,j;
 dword *ad1,*ad2;  
 byte *filein=new byte[440*13];
 byte *fileout=new byte[440*13];
 char *fntname=new char[256];

 // Test de l'existence du fichier  
 if ((FromF=fopen(name,"rb"))!=NULL)  
 {  
    fseek(FromF,1024+54,0);
    fread((void *)filein,1,440*13,FromF);  
    fclose(FromF);  
 }
 else  
	// Erreur d'ouverture  
	return 0;  
  
 // On inverse les donnees de la texture (stockees a l'envers dans le BMP)  
 // Pointeur sur premiere ligne de la texture  
 ad1=(dword *)fileout;  
 // Pointeur sur derniere ligne de la texture  
 ad2=(dword *)filein+110*12;
 // On inverse la moitie des lignes du haut avec celles du bas  
 for (i=0;i<13;i+=1)  
 {  
  // Inversion de la ligne courante et de sa symetrique  
  for (j=0;j<110;j+=1) *ad1++=*ad2++;
  ad2-=220;
 };  

 strcpy(fntname,name);
 char *pos=strchr(fntname,'.');
 strcpy(pos,".fnt");
 if ((ToF=fopen(fntname,"wb"))!=NULL)  
 {  
    fwrite((void *)fileout,1,440*13,ToF);  
    fclose(FromF);  
 }

 // Sortie sans erreur  
 return 1;  
}  


